/**
 *  joola.io
 *
 *  Copyright Joola Smart Solutions, Ltd. <info@joo.la>
 *
 *  Licensed under GNU General Public License 3.0 or later.
 *  Some rights reserved. See LICENSE, AUTHORS.
 *
 *  @license GPL-3.0+ <http://spdx.org/licenses/GPL-3.0+>
 */


var
  joola = global.joola, //for jslint
  url = require('url'),
  ce = require('cloneextend');

var list = function () {
  var permissions = [];
  var _permissions = joola.config.authentication.permissions;

  _.each(_permissions, function (permission) {
    permissions.push(permission);
  });

  return ce.clone(permissions);
};

var get = function (id) {
  var permissions = this.list();
  return ce.clone(_.find(permissions, function (permission) {
    return permission.id.toLowerCase() == id.toLowerCase();
  }));
};

exports.list = list;
exports.get = get;
